Attribute VB_Name = "SHFileOperation_Functions"
Type SHFILEOPSTRUCT
        hWnd As Long
        wFunc As Long
        pFrom As String
        pTo As String
        fFlags As Integer
        fAnyOperationsAborted As Boolean
        hNameMappings As Long
        lpszProgressTitle As String 'only used if
End Type

Type SHNAMEMAPPING
    OldPath As String
    NewPath As String
    cchOldPath As Integer ' Len of OldPath
    cchNewPath As Integer ' len of NewPath
End Type

Public Const WM_USER = &H200

' Actions
Public Const FO_MOVE = &H1
Public Const FO_COPY = &H2
Public Const FO_DELETE = &H3
Public Const FO_RENAME = &H4

' Flags
Public Const FOF_MULTIDESFILES = &H1
Public Const FOF_CONFIRMMOUSE = &H2
Public Const FOF_SILENT = &H4
Public Const FOR_RENAMEONCOLLISION = &H8
Public Const FOR_NONCONFIRMATION = &H10
Public Const FOR_WANTMAPPINGSHANDLE = &H20
Public Const FOR_ALLOWUNDO = &H40
Public Const FOR_FILESONLY = &H80
Public Const FOF_SIMPLEPROGRESS = &H100
Public Const FOR_NOCONFIRMMKDIR = &H200

' Error Codes
Public Const FOERR_CANCEL = &H75
Public Const FOERR_NOERROR = &H0


Type SHITEMID   'mkid
    cb As Long      'Size of the ID (including cb itself)
    abID As Byte   'The item ID (variable length)
End Type

Type ITEMIDLIST  'idl
    mkid As SHITEMID
End Type

Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Declare Function SHFileOperation Lib "shell32.dll" (lpFileOp As SHFILEOPSTRUCT) As Long
Declare Sub SHAddToRecentDocs Lib "shell32.dll" (ByVal uFlags As Long, ByVal pv As String)
Declare Sub SHFreeNameMappings Lib "shell32.dll" (ByVal hNameMappings As Long)
' Declare Function SHGetFileInfo Lib "shell32.dll" Alias " SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long



Public Const NOERROR = 0

'  SHGetSpecialFolderLocation "nFolder" param:
'  Value specifying the folder to retrieve the location of. This parameter
'  can be one of the following values: Most folder locations are stored in:
'  HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders

'  Windows desktop  virtual folder at the root of the name space.


Public Enum CSIDLEnum
    CSIDL_DESKTOP = &H0
    CSIDL_PROGRAMS = &H2
    CSIDL_CONTROLS = &H3
    CSIDL_PRINTERS = &H4
    CSIDL_PERSONAL = &H5       '  (Documents folder)
    CSIDL_FAVORITES = &H6
    CSIDL_STARTUP = &H7
    CSIDL_RECENT = &H8         '  (Recent folder)
    CSIDL_SENDTO = &H9
    CSIDL_BITBUCKET = &HA
    CSIDL_STARTMENU = &HB
    CSIDL_DESKTOPDIRECTORY = &H10
    CSIDL_DRIVES = &H11
    CSIDL_NETWORK = &H12
    CSIDL_NETHOOD = &H13
    CSIDL_FONTS = &H14
    CSIDL_TEMPLATES = &H15     '  (ShellNew folder)
End Enum

Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long 'ITEMIDLIST

Public Type BROWSEINFO    'bi
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long

End Type

'  BROWSEINFO.ulFlags values:
Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000

' SHChangeNotify Flags
Public Const SHCNE_ASSOCCHANGED = &H8000000
Public Const SHCNE_ATTRIBUTES = &H800
Public Const SHCNE_CREATE = &H2
Public Const SHCNE_DELETE = &H4
Public Const SHCNE_DRIVEADD = &H100
Public Const SHCNE_DRIVEADDGUI = &H10000
Public Const SHCNE_DRIVERMOVED = &H80
Public Const SHCNE_INTERRUPT = &H80000000
Public Const SHCNE_MEDIAINSERTED = &H20
Public Const SHCNE_MEDIAREMOVED = &H40
Public Const SHCNE_MKDIR = &H8
Public Const SHCNE_NETSHARE = &H200
Public Const SHCNE_NETUNSHARE = &H400
Public Const SHCNE_RENAMEFOLDER = &H20000
Public Const SHCNE_RENAMEITEM = &H1
Public Const SHCNE_RMDIR = &H10
Public Const SHCNE_SERVERDISCONNECT = &H4000
Public Const SHCNE_UPDATEDIR = &H1000
Public Const SHCNE_UDATEIMAGE = &H2000
Public Const SHCNE_UPDATEITEM = &H8000

Public Const SHCNF_DWORD = &H3
Public Const SHCNF_FLUSH = &H1000
Public Const SHCNF_FLUSHNOWART = &H2000
Public Const SHCNF_IDLIST = &H0
Public Const SHCNF_PATH = &H1
Public Const SHCNF_PRINTER = &H2

' BrowseCallbackProc
Public Const BFFM_ENABLEOK = WM_USER + &H101
Public Const BFFM_SETSTATUSTEXT = WM_USER + &H100
Public Const BFFM_INITIALIZED = &H1
Public Const BFFM_SELCHANGED = &H2

' SHAddToRecentDocs
Public Const SHARD_PATH = &H1
Public Const SHARD_PIDL = &H2

Public nFolder&
Public Function RecycleFile(ParamArray FileName() As Variant)
    
    ' Sample Calls
    ' Delete one file
    'x = RecycleFile("c:\TrashMe.txt")

    ' Delete several files
    'x = RecycleFile("c:\TrashMe.txt", "c:\MyData\JanReport.xls", "h:\MyApps\FooBar.exe")
 
    ' It also supports wildcards
    'x = RecycleFile("c:\MyData\*.xls")

    Dim RR As Integer
    Dim Files As String
    Dim ShellFileOper As SHFILEOPSTRUCT

    For RR = LBound(FileName) To UBound(FileName)
        Files = Files & FileName(RR) & vbNullChar
    Next

    Files = Files & vbNullChar

    With ShellFileOper
        .wFunc = &H3
        .pFrom = Files
        .fFlags = &H40
    End With
    
    RecycleFile = SHFileOperation(ShellFileOper)
End Function


Public Function BrowseForFolder$(nFolder As CSIDLEnum, Title As String, OwnerForm As Form)
    ' This function displays the win 95 Browse dialog box
    Dim udtBrowseInfo As BROWSEINFO
    Dim udtIDL As ITEMIDLIST
    Dim lngReturn, intpIDL, Path$, pos%
  
    '  the calling app
    udtBrowseInfo.hOwner = OwnerForm.hWnd
  
    '  set the folder to limit the browse to in the dialog
    '  if CurOptIdx% = 0 (Default Browse), udtBrowseInfo.pudtIDLRoot would then be Null
    If nFolder Then
        lngReturn = SHGetSpecialFolderLocation(ByVal OwnerForm.hWnd, ByVal nFolder, udtIDL)
        udtBrowseInfo.pidlRoot = udtIDL.mkid.cb
    End If
    
    '  set the banner text
    udtBrowseInfo.lpszTitle = Title
     
    '  set the type of folder to return
    '  play with these option constants to see what can be returned
    udtBrowseInfo.ulFlags = udtBrowseInfoF_RETURNONLYFSDIRS And udtBrowseInfoF_BROWSEFORCOMPUTER 'udtBrowseInfoF_RETURNFSANCESTORS 'udtBrowseInfoF_BROWSEFORPRINTER + udtBrowseInfoF_DONTGOBELOWDOMAIN
     
    '  show the browse folder dialog
    intpIDL = SHBrowseForFolder(udtBrowseInfo)
     
    '  if displaying the return value, get the selected folder
    Path$ = Space$(512)
    lngReturn = SHGetPathFromIDList(ByVal intpIDL, ByVal Path$)
    If lngReturn Then
        '  parse & display the folder selection
        pos% = InStr(Path$, Chr$(0))
        BrowseForFolder$ = Left(Path$, pos - 1)
    Else
        BrowseForFolder$ = ""
    End If
End Function

